var MGEvent = (function() {
    function a(b) {
        this.data = null;
        this.type = b
    }
    a.REWARD_AD = "REWARD_AD";
    a.LOAD_START = "LOAD_START";
    a.LOAD_PROGRESS = "LOAD_PROGRESS";
    a.LOAD_COMPLETE = "LOAD_COMPLETE";
    a.LOAD_ERROR = "LOAD_ERROR";
    a.START_GAME = "START_GAME";
    a.PAUSE_GAME = "PAUSE_GAME";
    a.WIN_GAME = "WIN_GAME";
    a.LOSE_GAME = "LOSE_GAME";
    a.ENTER_GAME = "ENTER_GAME";
    a.ADDED_TO_STAGE = "ADDED_TO_STAGE";
    a.FRAMEWORK_INFO_REQUEST = "FRAMEWORK_INFO_REQUEST";
    a.FRAMEWORK_INFO_RESPONSE = "FRAMEWORK_INFO_RESPONSE";
    a.CLICK_MORE = "CLICK_MORE";
    a.CLICK_MINILOGO = "CLICK_MINILOGO";
    a.OPEN_URL = "OPEN_URL";
    a.OPEN_EMAIL = "OPEN_EMAIL";
    a.SHARE = "SHARE";
    a.CLICK_CREDITS = "CLICK_CREDITS";
    a.SHOW_WIN = "SHOW_WIN";
    a.SHOW_LOSE = "SHOW_LOSE";
    a.LEVEL_FAIL = "LEVEL_FAIL";
    a.LEVEL_WIN = "LEVEL_WIN";
    a.SCREENSHOT = "SCREENSHOT";
    a.DOWNLOAD_APP = "DOWNLOAD_APP";
    a.CONTINUE_GAME = "CONTINUE_GAME";
    a.CHANGE_SCENE = "CHANGE_SCENE";
    a.FULLSCREEN = "FULLSCREEN";
    a.GAME_STARTUP = "GAME_STARTUP";
    return a
})();
MGEvent.prototype.__class__ = "MGEvent";
window.MGEvent = MGEvent;
var MGDelegate = (function() {
    function a() {}
    a.getListenerIndex = function(d, e, b) {
        if (!a._eventMap[d]) {
            return -1
        }
        for (var c = 0; c < a._eventMap[d].length; c++) {
            var f = a._eventMap[d][c];
            if (f[0] == e && f[1] == b) {
                return c
            }
        }
        return -1
    };
    a.hasListener = function(b) {
        if (!a._eventMap[b]) {
            return false
        }
        return true
    };
    a.addEventListener = function(c, d, b) {
        if (!a._eventMap[c]) {
            a._eventMap[c] = []
        }
        if (a.getListenerIndex(c, d, b) == -1) {
            a._eventMap[c].push([d, b])
        }
    };
    a.removeEventListener = function(d, e, b) {
        if (!a._eventMap[d]) {
            return
        }
        var c = a.getListenerIndex(d, e, b);
        if (c != -1) {
            a._eventMap[d].splice(c, 1)
        }
        if (a._eventMap[d].length == 0) {
            delete a._eventMap[d]
        }
    };
    a.dispatcherEvent = function(f) {
        var d = f.type;
        if (!a._eventMap[d]) {
            return
        }
        var b = a._eventMap[d];
        for (var c = 0; c < b.length; c++) {
            var h = b[c];
            var e = h[0];
            var g = h[1];
            e.call(g, f)
        }
    };
    a._eventMap = {};
    return a
})();
MGDelegate.prototype.__class__ = "MGDelegate";
window.MGDelegate = MGDelegate;
var com4j = {
    VERSION: "1.9.4",
    initCallbackObj: null,
    _isFullscreen: false,
    get fullscreenEnabled() {
        var a = document.fullscreenEnabled || document.mozFullScreenEnabled || document.webkitFullscreenEnabled;
        return !!a
    },
    fullscreen: function(a) {
        if (!com4j.fullscreenEnabled) {
            com4j.debug("Can not fullscreen, please check and set iframe allowfullscreen = 'allowfullscreen'");
            return
        }
        if (!a) {
            a = document.documentElement
        }
        if (a.requestFullscreen) {
            a.requestFullscreen()
        } else {
            if (a.msRequestFullscreen) {
                a.msRequestFullscreen()
            } else {
                if (a.mozRequestFullScreen) {
                    a.mozRequestFullScreen()
                } else {
                    if (a.webkitRequestFullScreen) {
                        a.webkitRequestFullScreen()
                    }
                }
            }
        }
    },
    exitFullscreen: function() {
        if (document.exitFullscreen) {
            document.exitFullscreen()
        } else {
            if (document.mozCancelFullScreen) {
                document.mozCancelFullScreen()
            } else {
                if (document.webkitExitFullscreen) {
                    document.webkitExitFullscreen()
                }
            }
        }
    },
    onFullscreenChanged: function(a) {
        com4j._isFullscreen = !com4j._isFullscreen
    }
};
com4j.config = {
    _isReady: false,
    parameters: {},
    getParam: function(a) {
        if (this.parameters.hasOwnProperty(a)) {
            if (this.parameters[a] === undefined || this.parameters[a] === null) {
                return true
            } else {
                return this.parameters[a]
            }
        } else {
            return undefined
        }
    },
    get isReady() {
        return this._isReady
    },
    set isReady(a) {
        this._isReady = a;
        if (a && com4j.game.isReady) {
            com4j.game.start()
        }
    },
    engineType: "unknow",
    canvasName: "gameCanvas",
    canvasId: "#gameCanvas",
    host: "./",
    ForJoyH5_pubid: "default",
    ForJoyH5_Fullscreen: true,
    ForJoyH5_ShowPreGameAd: false,
    ForJoyH5_PreGameAdType: "0,1",
    ForJoyH5_InGameAdInterval: 0,
    ForJoyH5_InGameAdType: "0,1",
    ForJoyH5_ShowCreditsButton: false,
    get ForJoy_gameid() {
        return window.hasOwnProperty("ForJoy_gameid") ? ForJoy_gameid : 293
    },
    ForJoyH5_DefaultBigLogo: "./game/logo/default_b.png?1466980738",
    _ForJoyH5_BigLogo: "./game/logo/default_b.png?1466980738",
    get ForJoyH5_BigLogo() {
        if (this.ForJoyH5_stats === false) {
            return this.ForJoyH5_DefaultBigLogo
        }
        return this._ForJoyH5_BigLogo
    },
    set ForJoyH5_BigLogo(a) {
        this._ForJoyH5_BigLogo = a
    },
    ForJoyH5_DefaultSmallLogo: "./game/logo/default_s.png?1466980738",
    _ForJoyH5_SmallLogo: "./game/logo/default_s.png?1466980738",
    get ForJoyH5_SmallLogo() {
        if (this.ForJoyH5_stats === false) {
            return this.ForJoyH5_DefaultSmallLogo
        }
        return this._ForJoyH5_SmallLogo
    },
    set ForJoyH5_SmallLogo(a) {
        this._ForJoyH5_SmallLogo = a
    },
    ForJoyH5_ShowMoreGamesDivWhenClickLogo: false,
    ForJoyH5_AdChannel: 7376568015,
    ForJoyH5_stats: false,
    ForJoyH5_ShowAd: false,
    ForJoyH5_ShowMoreGamesButton: false,
    _ForJoyH5_DefaultBgColor: "#008BCC",
    _ForJoyH5_BgColor: "#008BCC",
    get ForJoyH5_BgColor() {
        if (this.ForJoyH5_stats === false) {
            return this._ForJoyH5_DefaultBgColor
        }
        return this._ForJoyH5_BgColor
    },
    set ForJoyH5_BgColor(a) {
        this._ForJoyH5_BgColor = a
    },
    ForJoyH5_ShowCopyright: false,
    ForJoyH5_ShowAppLink: false,
    ForJoyH5_MoreGamesUrl: "no",
    ForJoyH5_ShowMoreGamesDivWhenGameOver: false,
    _ForJoyH5_Default_Website: "https://www.4j.com",
    _ForJoyH5_Website: "https://www.4j.com",
    get ForJoyH5_Website() {
        if (this.ForJoyH5_stats === false) {
            return this._ForJoyH5_Default_Website
        }
        return this._ForJoyH5_Website
    },
    set ForJoyH5_Website(a) {
        this._ForJoyH5_Website = a
    },
    ForJoyH5_mid: 19,
    NameID: "allgames",
    v: "",
    debug: false,
    devMode: false,
    showmsgs: [],
    sharemsgs: [],
    language: "en",
    HasScreenshot: false,
    touchEnabled: "ontouchstart" in window,
    init: function() {
        // var j = window.location.pathname;
        // var b = /(test\/|games\/|games-test\/)?([^/]+)/g;
        // var f = b.exec(j);
        // if (f && f[1] != undefined) {
        //     com4j.config.NameID = f[2]
        // }
        // var b = /(\s*)(.+)(\s*)/g;
        // if (document.cookie.length > 0) {
        //     var a = {};
        //     var d = document.cookie.split(";");
        //     for (var c = 0; c < d.length; c++) {
        //         var e = d[c].split("=");
        //         var h = e[0].replace(b, "$2");
        //         var g = decodeURIComponent(e[1]);
        //         a[h] = g
        //     }
        // }
        // $(document.body).css("background", com4j.config.ForJoyH5_BgColor)
    }
};
com4j.loadScript = function(d, e, c) {
    var b = document.createElement("script"),
        a = document.body;
    b.type = "text/javascript";
    b.charset = "UTF-8";
    b.src = d;
    if (b.addEventListener) {
        b.addEventListener("load", function() {
            e && e.apply(c, [c])
        }, false)
    } else {
        if (b.attachEvent) {
            b.attachEvent("onreadystatechange", function() {
                var f = window.event.srcElement;
                if (f.readyState == "loaded") {
                    e && e.apply(c, [c])
                }
            })
        }
    }
    document.body.appendChild(b)
};
com4j.resize = {
    _timerID: null,
    _queue: [],
    get sw() {
        return $(window).width()
    },
    get sh() {
        return $(window).height()
    },
    indexOf: function(e, c) {
        var b = 0,
            a = this._queue.length;
        for (b = 0; b < a; b++) {
            var d = this._queue[b];
            if (d.callback == e && d.context == c) {
                return b
            }
        }
        return -1
    },
    add: function(d, b, c) {
        var a = this.indexOf(d, b);
        if (a == -1) {
            if (c && c.constructor != Array) {
                c = [c]
            }
            this._queue.push({
                callback: d,
                context: b,
                params: c
            })
        } else {
            com4j.debug("has event")
        }
    },
    remove: function(a, c) {
        var b = -1;
        if (a.constructor == Number) {
            b = a
        } else {
            b = this.indexOf(a, c)
        } if (b > -1) {
            delete this._queue[b];
            this._queue.splice(b, 1)
        } else {
            com4j.debug("has event")
        }
    },
    handler: function(a) {
        if (com4j.resize._timerID) {
            clearTimeout(com4j.resize._timerID)
        }
        com4j.resize._timerID = setTimeout(com4j.resize._onHandler, 50)
    },
    _onHandler: function(g) {
        var c = 0,
            a = com4j.resize._queue.length;
        for (c = 0; c < a; c++) {
            var f = com4j.resize._queue[c];
            try {
                var d = f.callback;
                var b = f.context;
                var j = f.params;
                d.apply(b, j)
            } catch (h) {
                this.remove();
                com4j.debug("Can not execute, maybe deleted.")
            }
        }
    }
};
com4j.moregames = {
    hasData: false,
    moreData: null,
    MoreInterval: 60,
    _lastTime: -1,
    get showable() {
        if (this._lastTime === -1) {
            return true
        }
        var b = (new Date()).getTime();
        var a = b - this._lastTime;
        if (a >= this.MoreInterval * 1000) {
            return true
        } else {
            var c = Math.ceil(this.MoreInterval - a / 1000);
            com4j.debug("Please call com4j.more.show() later, wait " + c + "s");
            return false
        }
    },
    updateLastTime: function() {
        var a = (new Date()).getTime();
        this._lastTime = a
    },
    init: function() {
        var a = $(".new_ui_box-content");
        var c = $(".new_ui_games-list");
        var e = Math.floor(new Date().getTime() / 432000000);
        var d = com4j.config.host + "moregames/" + com4j.config.NameID + ".json?v=" + e;
        $.get(d, function(h, g, i) {
            if (g == "success") {
                com4j.moregames.moreData = h;
                com4j.moregames.hasData = true;
                com4j.moregames.randomInit()
            }
        }).fail(function() {
            com4j.moregames.hasData = false
        });

        function f() {
            var h = ($(window).height() - a.height()) / 2;
            if (h < 0) {
                h = 0
            }
            var g = ($(window).width() - a.width()) / 2;
            if (g < 0) {
                g = 0
            }
            a.css("margin-top", h + "px");
            a.css("margin-left", g + "px");
            c.css("height", (a.height() - 60) + "px")
        }
        com4j.resize.add(f, com4j.moregames);
        com4j.resize.handler();
        var b = com4j.config.touchEnabled ? "touchstart touchend" : "mouseup";
        $("#closeMoreBtn").bind(b, function(g) {
            if ($("#moregames").css("visibility") === "hidden") {
                return
            }
            com4j.moregames.close();
            g.stopPropagation();
            g.preventDefault()
        })
    },
    randomInit: function() {
        if (!com4j.moregames.moreData) {
            return
        }
        var d = com4j.moregames.moreData.concat();
        $(".new_ui_games-list").empty();
        var f = "";
        while (d.length > 0) {
            var b = Math.floor(Math.random() * d.length);
            var e = d[b];
            d.splice(b, 1);
            if (!com4j.config.ForJoyH5_ShowCopyright && e.hasOwnProperty("copyright") && e.copyright == true) {
                continue
            }
            var a = com4j.config.host + e.nameid + "/index.php?pubid=" + com4j.config.ForJoyH5_pubid;
            f += "<a href='" + a + "'>";
            f += "<div class='new_ui_big-button-menu new_ui_single-game-row'>";
            var g = com4j.config.host + "thumb/" + e.nameid + ".jpg";
            f += "<img class='new_ui_img-icon' src='" + g + "'>";
            f += "<p class='new_ui_game-info'>";
            f += "<span class='new_ui_game-name'>" + e.name + "</span>";
            f += "<span class='new_ui_stars-container'>";
            for (var c = 1; c <= 5; c++) {
                if (c < e.rating5) {
                    f += "<span class='new_ui_sprite new_ui_star-yellow'></span>"
                } else {
                    if (c > Math.floor(e.rating5) && c <= Math.ceil(e.rating5)) {
                        f += "<span class='new_ui_sprite new_ui_star-yellow-grey'></span>"
                    } else {
                        f += "<span class='new_ui_sprite new_ui_star-grey'></span>"
                    }
                }
            }
            f += "</span>";
            f += "</p>";
            f += "<span class='new_ui_sprite new_ui_button-next new_ui_icon-right-big-button'></span>";
            f += "</div>";
            f += "</a>"
        }
        $(".new_ui_games-list").append(f)
    },
    show: function(a) {
        if (com4j.moregames.hasData == false) {
            com4j.debug("get moregames data error.");
            return
        }
        if (!com4j.config.ForJoyH5_ShowMoreGamesDivWhenGameOver) {
            return
        }
        if (a) {
            com4j.moregames.randomInit();
            $("#moregames").css("visibility", "visible");
            com4j.modal.show();
            return
        }
        if (this.showable) {
            this.updateLastTime();
            com4j.moregames.randomInit();
            $("#moregames").css("visibility", "visible");
            com4j.modal.show()
        }
    },
    close: function() {
        if (com4j.moregames.hasData == false) {
            return
        }
        $("#moregames").css("visibility", "hidden");
        com4j.modal.hide()
    }
};
com4j.ad = {
    _callbackObj: null,
    intervalID: -1,
    _lastInGameAdTime: -1,
    _loaded: false,
    _requesting: false,
    _imaContainer: null,
    _videoContent: null,
    _adsManager: null,
    _adsLoader: null,
    _adsRequest: null,
    _finishedPre: false,
    get finishedPre() {
        return this._finishedPre
    },
    set finishedPre(a) {
        this._finishedPre = a
    },
    get adType() {
        var a = com4j.config.ForJoyH5_PreGameAdType;
        if (com4j.ad.finishedPre) {
            a = com4j.config.ForJoyH5_InGameAdType
        }
        switch (a) {
            case 0:
                return "all";
                break;
            case 1:
                return "onlyskipable";
                break;
            case 2:
                return "no";
                break
        }
    },
    get adTagUrl() {
        var b = "game=" + com4j.config.ForJoy_gameid + "&pubid=" + com4j.config.ForJoyH5_pubid + "&video=" + com4j.ad.adType + "&uid=" + com4j.config.ForJoyH5_pubid + "_" + com4j.config.ForJoy_gameid + "&mid=" + com4j.config.ForJoyH5_mid;
        b = encodeURIComponent(b);
        var a = "https://pubads.g.doubleclick.net/gampad/ads?sz=640x480&iu=/324879675/pregame_h5.4j.com_parnter&cust_params=" + b + "&impl=s&gdfp_req=1&env=vp&output=vast&unviewed_position_start=1";
        return a
    },
    check: function() {
        if (window.location.hostname === "localhost" || window.location.hostname === "127.0.0.1") {
            com4j.config.debug = true;
            return true
        }
        if (typeof google == "undefined" || typeof google.ima == "undefined") {
            com4j.loading.hideLoadingGif();
            setTimeout(function() {
                $("#blocktip").css("visibility", "visible");
                com4j.modal.show(0.8)
            }, 100);
            return false
        }
        return true
    },
    _init: function() {
        if (com4j.ad.intervalID == -1) {
            com4j.ad.intervalID = setTimeout(com4j.ad.onAdClose, 30000)
        }
        com4j.ad._imaContainer = $("#imaContainer")[0];
        com4j.ad._videoContent = $("#imaVideo")[0];
        var a = new google.ima.AdDisplayContainer(com4j.ad._imaContainer, com4j.ad._videoContent);
        a.initialize();
        com4j.ad._adsLoader = new google.ima.AdsLoader(a);
        com4j.ad._adsLoader.addEventListener(google.ima.AdsManagerLoadedEvent.Type.ADS_MANAGER_LOADED, com4j.ad.onAdsManagerLoaded, false);
        com4j.ad._adsLoader.addEventListener(google.ima.AdErrorEvent.Type.AD_ERROR, com4j.ad.onAdError, false);
        com4j.ad._videoContent.onended = com4j.ad.contentEndedListener;
        com4j.ad._adsRequest = new google.ima.AdsRequest();
        com4j.ad._adsRequest.adTagUrl = com4j.ad.adTagUrl;
        com4j.ad._adsRequest.linearAdSlotWidth = $(window).width();
        com4j.ad._adsRequest.linearAdSlotHeight = $(window).height();
        com4j.ad._adsRequest.nonLinearAdSlotWidth = $(window).width();
        com4j.ad._adsRequest.nonLinearAdSlotHeight = $(window).height();
        com4j.ad._adsRequest.forceNonLinearFullSlot = true;
        com4j.resize.add(com4j.ad.resizeAd, com4j.ad)
    },
    init: function() {
        var a = document.referrer;
        a = a.substr(a.indexOf("://") + 1);
        if ((com4j.config.ForJoyH5_ShowPreGameAd || a.indexOf(com4j.config.host) == 0) && com4j.config.ForJoyH5_stats) {
            com4j.ad.show()
        } else {
            com4j.ad.onAdClose()
        }
    },
    onAdsManagerLoaded: function(a) {
        com4j.ad._adsManager = a.getAdsManager(com4j.ad._videoContent);
        com4j.ad._adsManager.addEventListener(google.ima.AdErrorEvent.Type.AD_ERROR, com4j.ad.onAdError);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.ALL_ADS_COMPLETED, com4j.ad.onAllAdsCompleted);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.USER_CLOSE, com4j.ad.onUserClose);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.COMPLETE, com4j.ad.onAdComplete);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.LOADED, com4j.ad.onAdLoaded);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.SKIPPED, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.AD_BREAK_READY, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.AD_METADATA, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.CONTENT_PAUSE_REQUESTED, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.CONTENT_RESUME_REQUESTED, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.DURATION_CHANGE, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.FIRST_QUARTILE, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.IMPRESSION, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.LINEAR_CHANGED, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.LOADED, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.LOG, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.MIDPOINT, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.PAUSED, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.RESUMED, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.SKIPPABLE_STATE_CHANGED, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.STARTED, com4j.ad.onTypeTest);
        com4j.ad._adsManager.addEventListener(google.ima.AdEvent.Type.THIRD_QUARTILE, com4j.ad.onTypeTest);
        com4j.ad._adsManager.init(window.innerWidth, window.innerHeight, google.ima.ViewMode.FULLSCREEN);
        com4j.ad._adsManager.start()
    },
    onTypeTest: function(a) {},
    onAdLoaded: function(c) {
        clearTimeout(com4j.ad.intervalID);
        $(com4j.ad._imaContainer).css("visibility", "visible");
        $(com4j.ad._imaContainer).children(":first").css("visibility", "visible");
        com4j.ad._loaded = true;
        var d = com4j.ad._adsManager.getCurrentAd().getContentType();
        var b = 0;
        if (d == "text") {
            b = 0
        } else {
            if (d == "image/png") {
                b = 1
            } else {
                b = 2
            }
        }
        var a = new MGEvent("CMD_AD_TYPE_LOG");
        a.data = {
            ad_type: b
        };
        MGDelegate.dispatcherEvent(a)
    },
    contentEndedListener: function() {
        com4j.ad._adsLoader.contentComplete()
    },
    onAdError: function(a) {
        console.warn(a.getError());
        com4j.ad.onAdClose()
    },
    onAdComplete: function(a) {},
    onAllAdsCompleted: function(a) {
        com4j.ad.onAdClose()
    },
    onAdClose: function() {
        var a = "AD_CLOSE";
        if (com4j.ad.finishedPre == false) {
            a = a + "_PRE";
            com4j.ad.finishedPre = true
        }
        com4j.ad.close();
        MGDelegate.dispatcherEvent(new MGEvent(a))
    },
    onUserClose: function(a) {
        com4j.ad.onAdClose()
    },
    resizeAd: function() {
        if (com4j.ad._adsManager) {
            com4j.ad._adsManager.resize($(window).width(), $(window).height(), google.ima.ViewMode.FULLSCREEN)
        }
    },
    _onFinishedAd: function() {
        com4j.modal.hide();
        var b = com4j.ad._callbackObj;
        if (!b) {
            return
        }
        var d = b.callback;
        var c = b.thisObj;
        var a = b.args;
        d.apply(c, a);
        com4j.ad._callbackObj = null
    },
    getShowable: function(d) {
        if (com4j.ad._lastInGameAdTime === -1 || d) {
            return true
        }
        var b = (new Date()).getTime();
        var a = b - com4j.ad._lastInGameAdTime;
        if (a >= com4j.config.ForJoyH5_InGameAdInterval * 1000) {
            return true
        } else {
            var c = Math.ceil(com4j.config.ForJoyH5_InGameAdInterval - a / 1000);
            com4j.debug("Please call com4j.ad.show() later, wait " + c + "s");
            return false
        }
    },
    updateLastInGameAdTime: function() {
        var a = (new Date()).getTime();
        com4j.ad._lastInGameAdTime = a
    },
    show: function(b, d) {
        if (!com4j.config.ForJoyH5_ShowAd) {
            if (b) {
                var e = b;
                var g = e.callback;
                var f = e.thisObj;
                var a = e.args;
                g.apply(f, a);
                com4j.ad._callbackObj = null
            }
            return
        }
        if (!this.check()) {
            return
        }
        var c = this.getShowable(d);
        if (!c && b) {
            var e = b;
            var g = e.callback;
            var f = e.thisObj;
            var a = e.args;
            g.apply(f, a);
            com4j.ad._callbackObj = null;
            return
        }
        com4j.modal.show();
        com4j.ad._callbackObj = b;
        if (!com4j.ad._adsRequest) {
            com4j.ad._init()
        }
        if (!com4j.config.ForJoyH5_stats && !d) {
            com4j.ad._onFinishedAd();
            return
        }
        if (com4j.ad._requesting) {
            com4j.debug("Is requesting Ad....");
            return
        }
        if (c || d) {
            com4j.ad._requesting = true;
            clearTimeout(com4j.ad.intervalID);
            com4j.ad.intervalID = setTimeout(com4j.ad.onAdClose, 30000);
            $(com4j.ad._imaContainer).css("display", "");
            com4j.loading.showLoadingGif();
            com4j.ad._adsLoader.requestAds(com4j.ad._adsRequest);
            com4j.ad.resizeAd()
        } else {
            com4j.ad._onFinishedAd()
        }
    },
    close: function() {
        if (com4j.ad._loaded == true) {
            com4j.ad.updateLastInGameAdTime()
        }
        com4j.ad._requesting = false;
        com4j.loading.hideLoadingGif();
        com4j.ad._loaded = false;
        clearTimeout(com4j.ad.intervalID);
        com4j.ad._adsManager && com4j.ad._adsManager.destroy();
        $(com4j.ad._imaContainer).css("display", "none");
        com4j.ad._onFinishedAd();
        MGDelegate.dispatcherEvent(new MGEvent("CMD_AD_CLOSE"));
        com4j.modal.hide()
    }
};
com4j.game = {
    _isReady: false,
    get isReady() {
        return this._isReady
    },
    set isReady(a) {
        this._isReady = a;
        if (a && com4j.config.isReady) {
            com4j.game.start()
        }
    },
    game_url: "",
    inited: false,
    _enterGameEnabled: false,
    _lastLeft: NaN,
    _lastTop: NaN,
    set enterGameEnabled(a) {
        this._enterGameEnabled = a;
        if (a) {
            this.enterGame()
        }
    },
    get enterGameEnabled() {
        return this._enterGameEnabled
    },
    c2Ready: function(a) {
        com4j.config.engineType = "c2";
        $(com4j.config.canvasId).css("position", "absolute");
        $(a).attr("onload", com4j.game.c2GameLoaded)
    },
    c2GameLoaded: function() {
        com4j.game.isReady = true
    },
    c2GameStart: function() {
        cr_createRuntime(com4j.config.canvasName);
        cr.runtime.prototype._progress = 0;
        window.cr_getC2Runtime = function() {
            var b = document.getElementById("gameCanvas");
            if (b) {
                return b.c2runtime
            } else {
                if (window.c2runtime) {
                    return window.c2runtime
                } else {
                    return null
                }
            }
        };
        Object.defineProperty(cr.runtime.prototype, "progress", {
            get: function() {
                return cr.runtime.prototype._progress
            },
            set: function(c) {
                if (c < 1) {
                    var b = new MGEvent(MGEvent.LOAD_PROGRESS);
                    b.data = {
                        percent: c * 100
                    };
                    MGDelegate.dispatcherEvent(b)
                } else {
                    MGDelegate.dispatcherEvent(new MGEvent(MGEvent.LOAD_COMPLETE))
                }
                cr.runtime.prototype._progress = c
            }
        });

        function a() {
            if (document.hidden || document.mozHidden || document.webkitHidden || document.msHidden) {
                cr_setSuspended(true)
            } else {
                cr_setSuspended(false)
            }
        }
        document.addEventListener("visibilitychange", a, false);
        document.addEventListener("mozvisibilitychange", a, false);
        document.addEventListener("webkitvisibilitychange", a, false);
        document.addEventListener("msvisibilitychange", a, false)
    },
    cocosReady: function(a) {
        com4j.config.engineType = "cocos";
        $(a).attr("onload", com4j.game.cocosEngineLoaded);
        a = $("script[src='game.js']")[0];
        $(a).attr("onload", com4j.game.cocosGameLoaded)
    },
    cocosEngineLoaded: function() {
        $(com4j.config.canvasId).css("position", "")
    },
    cocosGameLoaded: function(a) {
        com4j.game.isReady = true
    },
    cocosStart: function() {
        if (MGDelegate.hasListener(MGEvent.GAME_STARTUP)) {
            MGDelegate.dispatcherEvent(new MGEvent(MGEvent.GAME_STARTUP))
        } else {
            try {
                cc.game.run()
            } catch (a) {
                com4j.debug("cc.game.run() not found")
            }
        }
    },
    createJsReady: function(a) {
        com4j.config.engineType = "createjs"
    },
    createJsStart: function() {},
    preInit: function() {
        com4j.game._listenEvents();
        MGDelegate.addEventListener("AD_CLOSE_PRE", function(c) {
            if (com4j.game.inited == true) {
                com4j.game.init()
            } else {
                com4j.game.inited = true
            }
        }, this);
        if ($("script[data-load]").data("load")) {
            com4j.config.engineType = "cocos";
            $(com4j.config.canvasId).css("position", "");
            $vers = $("script[data-load]").data("load").split(",");
            com4j.loading.totalStep = $vers.length;
            var b = 0;
            for (var a = 0; a < $vers.length - 1; a++) {
                com4j.loadScript($vers[a], function() {
                    b++;
                    if (b == $vers.length - 1) {
                        if (com4j.game.inited == true) {
                            com4j.game.init()
                        } else {
                            com4j.game.inited = true
                        }
                    }
                }, com4j.game)
            }
            this.game_url = $vers[$vers.length - 1]
        }
    },
    _listenEvents: function() {
        var d = function(g) {
			console.log("log:"+g.type);
            com4j.debug(g.type);
            switch (g.type) {
                case MGEvent.CLICK_CREDITS:
                    com4j.ga.sendEvent("GAME", g.type);
                    com4j.credits.show();
                    break;
                case MGEvent.CLICK_MINILOGO:
                    // com4j.ga.sendEvent("GAME", g.type);
                    // if (com4j.config.ForJoyH5_stats === false) {
                    //     window.open(com4j.config.ForJoyH5_Website, "_blank")
                    // } else {
                    //     if (com4j.config.ForJoyH5_MoreGamesUrl !== "no") {
                    //         window.open(com4j.config.ForJoyH5_MoreGamesUrl, "_blank")
                    //     } else {
                    //         if (com4j.config.ForJoyH5_ShowMoreGamesDivWhenClickLogo) {
                    //             com4j.moregames.show(true)
                    //         }
                    //     }
                    // }
                    break;
                case MGEvent.CLICK_MORE:
                    // com4j.ga.sendEvent("GAME", g.type);
                    // if (com4j.config.ForJoyH5_stats === false) {
                    //     window.open(com4j.config.ForJoyH5_Website, "_blank")
                    // } else {
                    //     if (com4j.config.ForJoyH5_MoreGamesUrl !== "no") {
                    //         window.open(com4j.config.ForJoyH5_MoreGamesUrl, "_blank")
                    //     } else {
                    //         com4j.moregames.show(true)
                    //     }
                    // }
                    break;
                case MGEvent.DOWNLOAD_APP:
                    // var e = g.data.platform;
                    // com4j.ga.sendEvent("GAME", g.type, e);
                    break;
                case MGEvent.FRAMEWORK_INFO_REQUEST:
                    var f = new MGEvent(MGEvent.FRAMEWORK_INFO_RESPONSE);
                    f.data = {
                        debug: com4j.config.debug,
                        gamename: com4j.config.NameID,
                        nameid: com4j.config.NameID,
                        miniLogoUrl: com4j.config.ForJoyH5_SmallLogo,
                        showmsgs: com4j.config.showmsgs,
                        sharemsgs: com4j.config.sharemsgs,
                        language: com4j.config.language,
                        HasScreenshot: com4j.config.HasScreenshot,
                        showCredits: com4j.config.ForJoyH5_ShowCreditsButton,
                        showMoreGamesButton: com4j.config.ForJoyH5_ShowMoreGamesButton,
                        fullscreenEnabled: com4j.config.ForJoyH5_Fullscreen
                    };
                    MGDelegate.dispatcherEvent(f);
                    break;
                case MGEvent.LOAD_COMPLETE:
                    break;
                case MGEvent.PAUSE_GAME:
                    com4j.ga.sendEvent("GAME", g.type);
                    break;
                case MGEvent.SCREENSHOT:
                    com4j.ga.sendEvent("GAME", g.type);
                    break;
                case MGEvent.SHARE:
                    com4j.ga.sendEvent("GAME", g.type);
                    break;
                case MGEvent.SHOW_LOSE:
                //insertVideoAd(50);
                    showNativeAd("lose");
                    com4j.ga.sendEvent("GAME", g.type);
                    com4j.moregames.show(false);
                    com4j.ad.show();
                    break;
                case MGEvent.SHOW_WIN:
                    com4j.ga.sendEvent("GAME", g.type);
                    com4j.moregames.show(false);
                    com4j.ad.show();
                    break;
                case MGEvent.LEVEL_FAIL:
                    var h = g.data.level;
                    com4j.ga.sendEvent("GAME", g.type, h);
                    com4j.moregames.show(false);
                    com4j.ad.show();
                    break;
                case MGEvent.LEVEL_WIN:
                    var h = g.data.level;
                    com4j.ga.sendEvent("GAME", g.type, h);
                    com4j.ad.show();
                    break;
                case MGEvent.START_GAME:
                    com4j.ga.sendEvent("GAME", g.type);
                    break;
                case MGEvent.CONTINUE_GAME:
                    com4j.ga.sendEvent("GAME", g.type);
                    break;
                case MGEvent.ADDED_TO_STAGE:
                    com4j.ga.sendEvent("GAME", g.type);
                    break;
                case MGEvent.CHANGE_SCENE:
                    com4j.ad.show(g.data);
                    break;
                case MGEvent.FULLSCREEN:
                    if (!com4j.config.ForJoyH5_Fullscreen) {
                        break
                    }
                    com4j.ga.sendEvent("GAME", g.type, !com4j._isFullscreen);
                    if (com4j._isFullscreen) {
                        com4j.exitFullscreen()
                    } else {
                        com4j.fullscreen()
                    }
                    break;
                case MGEvent.REWARD_AD:
                    console.log("run-sausage555");
                    com4j.ad.show(g.data, true);
                    break;
                default:
                    break
            }
        };
        var c = [MGEvent.CLICK_CREDITS, MGEvent.CLICK_MINILOGO, MGEvent.CLICK_MORE, MGEvent.DOWNLOAD_APP, MGEvent.FRAMEWORK_INFO_REQUEST, MGEvent.LOAD_COMPLETE, MGEvent.PAUSE_GAME, MGEvent.SCREENSHOT, MGEvent.SHARE, MGEvent.SHOW_LOSE, MGEvent.SHOW_WIN, MGEvent.LEVEL_FAIL, MGEvent.LEVEL_WIN, MGEvent.START_GAME, MGEvent.CONTINUE_GAME, MGEvent.ADDED_TO_STAGE, MGEvent.CHANGE_SCENE, MGEvent.FULLSCREEN, MGEvent.REWARD_AD];
        for (var b = 0, a = c.length; b < a; b++) {
            MGDelegate.addEventListener(c[b], d, this)
        }
        MGDelegate.addEventListener(MGEvent.LOAD_START, this.onLoadStart, this);
        MGDelegate.addEventListener(MGEvent.LOAD_PROGRESS, this.onLoadProgress, this);
        MGDelegate.addEventListener(MGEvent.LOAD_COMPLETE, this.onLoadComplete, this)
    },
    init: function() {
        com4j.loadScript(com4j.game.game_url, function() {
            setTimeout(function() {
                com4j.game.start()
            }, 100)
        }, com4j.game);
        com4j.loading.hideLoadingGif()
    },
    onLoadStart: function(a) {},
    onLoadProgress: function(b) {
        var a = b.data.percent;
        com4j.loading.setProgress(a)
    },
    onLoadComplete: function(d) {
        var c = 100;
        com4j.loading.setProgress(c);
        var b = new Date().getTime() - com4j.ga._loadStart;
        com4j.ga.sendTiming("LOAD_TIME", b);
        var a = function() {
            $("#preloaded").animate({
                opacity: 1,
                marginTop: 0,
                height: 80,
                width: 80
            }, 200, "linear")
        };
        var e = function() {
            $("#preloaded").animate({
                opacity: 1,
                marginTop: 4,
                height: 72,
                width: 72
            }, 100, "linear", a)
        };
        $("#hourglass").animate({
            opacity: 0
        }, 200);
        $("#preloadingB").animate({
            opacity: 0
        }, 200, function() {
            $("#hourglass").remove();
            $("#preloaded").animate({
                opacity: 1,
                marginTop: 0,
                height: 80,
                width: 80
            }, 300, "linear", function() {
                e();
                $("#preloaded").on("click", function() {
                    if (com4j.ad.getShowable()) {
                        var f = {
                            callback: function() {
                                com4j.game.enterGameEnabled = true
                            }
                        };
                        com4j.ad.show(f, true)
                    } else {
                        com4j.game.enterGameEnabled = true
                    }
                    $("#preloaded").remove()
                })
            })
        });
        setInterval(function() {
            com4j.game.resizeGame()
        }, 100);
        com4j.resize.handler()
    },
    enterGame: function() {
        setTimeout(function() {
            MGDelegate.dispatcherEvent(new MGEvent(MGEvent.ENTER_GAME));
            com4j.loading.destroy()
        }, 50)
    },
    resizeGame: function() {
        var a = $(com4j.config.canvasId).width();
        var b = $(com4j.config.canvasId).height();
        var d = Math.floor((com4j.resize.sw - a) / 2);
        var c = Math.floor((com4j.resize.sh - b) / 2);
        if (com4j.game._lastLeft != d || com4j.game._lastTop != c) {
            $(com4j.config.canvasId).css("left", d + "px");
            $(com4j.config.canvasId).css("top", c + "px")
        }
    },
    start: function() {
        if (com4j.config.engineType == "cocos") {
            this.cocosStart()
        } else {
            if (com4j.config.engineType == "c2") {
                this.c2GameStart()
            }
        }
    }
};
com4j.ga = {
    _loadStart: new Date().getTime(),
    send: function() {
        var a = ["send"].concat(arguments.length === 1 ? [arguments[0]] : Array.apply(null, arguments));
        if (typeof window.ga !== "function") {
            com4j.debug("'ga' can not found!");
            return
        } else {
            com4j.debug("ga", a)
        }
        window.ga.apply(window, a)
    },
    sendEvent: function(b, a, d, e, f) {
        var c = ["event", com4j.config.NameID].concat(arguments.length === 1 ? [arguments[0]] : Array.apply(null, arguments));
        this.send.apply(window, c)
    },
    sendTiming: function(a, e, d, c, f) {
        var b = ["timing", com4j.config.NameID].concat(arguments.length === 1 ? [arguments[0]] : Array.apply(null, arguments));
        this.send.apply(window, b)
    },
    sendSocial: function(c, b, d, e) {
        var a = ["social", com4j.config.NameID].concat(arguments.length === 1 ? [arguments[0]] : Array.apply(null, arguments));
        this.send.apply(window, a)
    },
    sendException: function(c, b) {
        var a = ["exception"].concat(arguments.length === 1 ? [arguments[0]] : Array.apply(null, arguments));
        this.send.apply(window, a)
    }
};
com4j.share = {
    config: null,
    init: function() {
        com4j.share.config = {
            qq: com4j.share._toQQ,
            weibo: com4j.share._toWeibo,
            weixin: com4j.share._toWeixin,
            twitter: com4j.share._toTwitter,
            facebook: com4j.share._toFacebook
        }
    },
    to: function(a, f, c, b, d) {
        a = a.toLowerCase();
        var e = com4j.share.config[a];
        if (e) {
            f = encodeURIComponent(f);
            c = encodeURIComponent(c);
            b = encodeURIComponent(b);
            d = encodeURIComponent(d);
            e.apply(this, [f, c, b, d])
        }
    },
    _toWeixin: function(d, b, a, c) {
        try {
            if (typeof(wxInfo) == "undefined") {} else {
                wxInfo.desc = a;
                UpdateWeiXin()
            }
        } catch (f) {}
    },
    _getTopHref: function() {
        try {
            return top.location.href
        } catch (a) {
            return false
        }
    },
    _toQQ: function(e, c, b, d) {
        // var f = com4j.share._getTopHref() || com4j.config.host + e + "/index.php?pubid=" + d;
        // f = encodeURIComponent(f);
        // var a = "https://sns.qzone.qq.com/cgi-bin/qzshare/cgi_qzshare_onekey?url=" + f + "&title=" + c + " &pics=" + com4j.config.host + "thumb/" + e + ".jpg&summary=" + b;
        // window.open(a)
    },
    _toWeibo: function(e, c, b, d) {
        // var f = com4j.share._getTopHref() || com4j.config.host + e + "/index.php?pubid=" + d;
        // f = encodeURIComponent(f);
        // var a = "https://service.weibo.com/share/share.php?url=" + f + "&title=" + b + "&searchPic=true&pic=" + com4j.config.host + "thumb/" + e + ".jpg";
        // window.open(a)
    },
    _toFacebook: function(e, c, b, d) {
        // var f = com4j.share._getTopHref() || com4j.config.host + e + "/index.php?pubid=" + d;
        // f = encodeURIComponent(f);
        // var a = "https://www.facebook.com/dialog/feed?app_id= 1692226401062334&display=popup&caption=" + b + "&link=" + f + "&redirect_uri=" + f + "&picture=" + com4j.config.host + "thumb/" + e + ".jpg";
        // window.open(a)
    },
    _toTwitter: function(e, c, b, d) {
        // var f = com4j.share._getTopHref() || com4j.config.host + e + "/index.php?pubid=" + d;
        // f = encodeURIComponent(f);
        // var a = "https://twitter.com/share?text=" + b + "&url=" + f;
        // window.open(a)
    }
};
com4j.credits = {
    init: function() {
        var a = com4j.config.touchEnabled ? "touchstart touchend" : "mouseup";
        $("#closeCreditsBtn").bind(a, function(b) {
            if ($("#credtis").css("visibility") === "hidden") {
                return
            }
            com4j.credits.close();
            b.stopPropagation();
            b.preventDefault()
        })
    },
    show: function() {
        $("#credits").css("visibility", "visible");
        com4j.modal.show()
    },
    close: function() {
        $("#credits").css("visibility", "hidden");
        com4j.modal.hide()
    }
};
com4j.modal = {
    intervalID: -1,
    init: function() {
        function a(b) {
            if ($(this).css("visibility") === "hidden") {
                return
            }
            if (b.target == b.currentTarget) {
                b.stopPropagation();
                b.preventDefault()
            }
        }
        $("#modal").bind("touchstart touchend touchmove mousedown mouseup mousemove", a)
    },
    show: function(a) {
        $("#modal").css("visibility", "visible");
        a = typeof a === "undefined" ? 0 : a;
        $("#modal").css("background", "rgba(0,0,0," + a + ")")
    },
    checkAllHide: function() {},
    hide: function() {
        var a = true;
        $("body > div").each(function(b, c) {
            if ($(this)[0] != $("#modal")[0]) {
                if ($(this)[0].id == "moregames" && $(this)[0].id == "credits" && $(this)[0].id == "imaContainer") {
                    if ($(this).css("display") == "none" || $(this).css("visibility") == "hidden") {} else {
                        a = false
                    }
                }
            }
        });
        if (a) {
            if (com4j.modal.intervalID) {
                clearTimeout(com4j.modal.intervalID)
            }
            com4j.modal.intervalID = setTimeout(function() {
                $("#modal").css("visibility", "hidden")
            }, 100)
        }
    }
};
com4j.loading = {
    currentStep: 0,
    totalStep: 1,
    init: function() {
        $("#preloadingRoot").css("background", com4j.config.ForJoyH5_BgColor);
        $("#logoImg").attr("src", com4j.config.ForJoyH5_BigLogo);
        $("#logoImg").load(function() {
            com4j.loading.resizeLogo();
            $("#preloadingContainer").css("visibility", "visible")
        });
        com4j.resize.add(com4j.loading.resizeLogo, this)
    },
    resizeLogo: function() {
        $("#preloadingContainer").css("left", (com4j.resize.sw - $("#preloadingContainer").width()) / 2 + "px");
        $("#preloadingContainer").css("top", (com4j.resize.sh - $("#preloadingContainer").height()) / 2 + "px")
    },
    setProgress: function(a) {
        $("#preloadingF").css("width", a + "%")
    },
    showLoadingGif: function() {
        $("#loadingGif").css("display", "");
        com4j.modal.show()
    },
    hideLoadingGif: function() {
        $("#loadingGif").css("display", "none");
        com4j.modal.hide()
    },
    show: function() {
        com4j.loading.resizeLogo();
        $("#preloadingRoot").css("visibility", "visible")
    },
    hide: function() {
        com4j.loading.resizeLogo();
        $("#preloadingRoot").css("visibility", "hidden");
        com4j.modal.hide()
    },
    destroy: function() {
        $("#preloadingRoot").remove();
        com4j.modal.hide()
    }
};
com4j.debug = function() {
    var b = function() {
        console.group();
        var f = (arguments.length === 1 ? [arguments[0]] : Array.apply(null, arguments));
        for (var g = 0, d = f.length; g < d; g++) {
            var c = f[g];
            if (typeof c === "string") {
                var h = "color:yellow;background:green;";
                var e = "%c%s";
                if (com4j.config.devMode) {
                    console.trace(e, h, c)
                } else {
                    console.log(e, h, c)
                }
            } else {
                if (com4j.config.devMode) {
                    console.trace(c)
                } else {
                    console.log(c)
                }
            }
        }
        console.groupEnd()
    };
    if (com4j.config.debug) {
        var a = (arguments.length === 1 ? [arguments[0]] : Array.apply(null, arguments));
        b.apply(null, a)
    }
};
com4j.ready = function() {
    function a(b) {
        if ($(this).css("visibility") === "hidden") {
            return
        }
        if (b.target == b.currentTarget) {
            b.stopPropagation();
            b.preventDefault()
        }
    }
    $("body > div").bind("touchstart touchend mousedown mouseup", a);
    $("script[src]").each(function(b, c) {
        if ($(c).attr("src").indexOf("c2runtime.js") != -1) {
            com4j.game.c2Ready(c)
        } else {
            if ($(c).attr("src").indexOf("cocos") != -1) {
                com4j.game.cocosReady(c)
            } else {
                if ($(c).attr("src").indexOf("createjs") != -1) {
                    com4j.game.createJsReady(c)
                }
            }
        }
    })
};
com4j.init = function() {
    var h = "color:yellow;background:green;";
    var a = "%c%s";
    console.log(a, h, "Com4jAPI VERSION " + this.VERSION);
    window.addEventListener("resize", com4j.resize.handler);
    window.onorientationchange = com4j.resize.handler;
    document.addEventListener("fullscreenchange", com4j.onFullscreenChanged, false);
    document.addEventListener("mozfullscreenchange", com4j.onFullscreenChanged, false);
    document.addEventListener("webkitfullscreenchange", com4j.onFullscreenChanged, false);
    document.addEventListener("msfullscreenchange", com4j.onFullscreenChanged, false);
    com4j.config.init();
    com4j.game.preInit();
    var g = '<canvas id="gameCanvas" style="position: absolute;" width="0" height="0"></canvas><div id="modal"></div><div id="preloadingRoot"><div id="preloadingContainer"><img id="logoImg"><div id="preloadingB" style="overflow: auto;"><div id="preloadingF"></div></div><div id="hourglass"></div><div id="preloaded"></div></div></div><div id="loadingGif"><div class="new_ui_loading-gif"></div></div><div id="moregames" class="more_container"><div class="new_ui_box-content"><p id="closeMoreBtn" class="new_ui_sprite new_ui_button-close"></p><div class="new_ui_games-list"></div></div></div><div id="imaContainer"><video id="imaVideo"></video></div><div id="credits"><p id="closeCreditsBtn" class="new_ui_sprite new_ui_button-close"></p><a href="https://w.4j.com/html5games" target="_blank"><img src="' + com4j.config.ForJoyH5_BigLogo + '"><p>Developed By 4J.Com<br>Free HTML5 Games For Your Site</p></a></div><div id="blocktip"><p>Please disable the ad blocker, and then refresh the page to enjoy the game, for free! </p><br><p>Thank you for your support.</p><br><a href="//help.stan.com.au/hc/en-us/articles/204778087-How-do-I-disable-AdBlock-" target="_blank">How to disable it?</a></div> ';
    $(document.body).append(g);
    com4j.modal.init();
    var e = "default";
    var b = "";
    if (window.location.search != "") {
        var f = window.location.search.substring(1).split(/&/).reduce(function(j, i) {
            var k = i.split(/=/);
            j[k[0]] = k[1];
            return j
        }, {});
        e = f.pubid || "default";
        b = f.v || "";
        if (f.hasOwnProperty("debug") || f.hasOwnProperty("_ijt")) {
            com4j.config.debug = true
        }
        if (f.hasOwnProperty("dev") && com4j.config.debug) {
            com4j.config.devMode = true
        }
        com4j.config.parameters = f
    }
    var d = true;
    // if (window.location.hostname == "localhost" || window.location.hostname == "127.0.0.1" || window.location.hostname == "office.miagame.com") {
    //     d = false;
        com4j.config.debug = true
    // }
    com4j.config.ForJoyH5_pubid = e;
    com4j.config.v = b;
    var c =  "./game/setting/" + e + ".json?" + b;
    $.get(c, function(n, j, o) {
        if (j == "success") {
            for (var l in n) {
                var k = "ForJoyH5_" + l;
                if (com4j.config.hasOwnProperty(k)) {
                    var m = n[l];
                    if (typeof m == "string") {
                        m = decodeURIComponent(m)
                    }
                    com4j.config[k] = m
                }
            }
            com4j.config.ForJoyH5_Fullscreen = com4j.fullscreenEnabled && com4j.config.ForJoyH5_Fullscreen
        }
    }).fail(function() {}).always(function() {
        if (com4j.config.ForJoyH5_ShowAd && !com4j.ad.check()) {
            com4j.ga.sendException("The ad is blocked.", false);
            // $.get("//freegeoip.net/json/", function(n) {
            //     var m = n.country_code + "/" + n.country_name + "/" + n.region_code + "/" + n.region_name + "/" + n.city;
            //     com4j.ga.sendEvent("ADVERTISING", "BLOCKED", m)
            // });
            return
        }
        com4j.credits.init();
        com4j.moregames.init();
        com4j.ad.init();
        com4j.loading.init();
        com4j.share.init();
        com4j.config.isReady = true;
        if (d) {
            var i = "./ajax_addgameplay.php?pubid=" + com4j.config.ForJoyH5_pubid + "&mid=" + com4j.config.ForJoyH5_mid + "&game=" + com4j.config.ForJoy_gameid + "";
            $.get(i)
        }
        $(document.body).css("background", com4j.config.ForJoyH5_BgColor);
        $(document.documentElement).css("background", com4j.config.ForJoyH5_BgColor);
        com4j.resize.handler();
        if (com4j.initCallbackObj) {
            var l = com4j.initCallbackObj.callback;
            var j = com4j.initCallbackObj.context;
            var k = com4j.initCallbackObj.params;
            l.apply(j, k)
        }
    })
};
window.com4j = com4j;
$(document).ready(function() {
    com4j.init();
    com4j.ready()
});

//记录分数
function reportScore(a){console.log("funtouch：logScore");document.location = "magic://game?score="+a;}
//弹出插屏
function insertInterstitialAd(a){console.log("funtouch：insertInterstitial"+a);document.location = "magic://ad?type=interstitial&position=top&random="+a;}
//弹出video
function insertVideoAd(a){console.log("funtouch：insertVideo"+a);document.location = "magic://ad?type=video&position=top&random="+a;}
//弹出banner
function insertBannerAd(){console.log("funtouch：insertBanner");document.location = "magic://ad?type=banner&position=bottom";}
//弹出激励
function insertRewardAd(){console.log("funtouch：insertRewardAd");document.location = "magic://ad?type=reward&position=top"}
//重新加载
function reloadurl(){console.log("funtouch：reloadurl");document.location = "magic://game?type=reloadurl&position=top"}
